<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

session_start();

if ($_SESSION['username'] != "")
{

	if ($_REQUEST['auto_value'] == "" && $_SESSION['refresh'] == "")
	{
		$auto_refresh = "30";
		$_SESSION['refresh'] = $auto_refresh;
	}
	elseif ($_REQUEST['auto_value'] == "" && $_SESSION['refresh'] == 30)
	{
		$auto_refresh = "30";
		$_SESSION['refresh'] = $auto_refresh;
	}
	elseif ($_REQUEST['refresh_button'] == "Update Interval")
	{	
		$auto_refresh = $_REQUEST['auto_value'];
		$_SESSION['refresh'] = $auto_refresh;
	}
	elseif ($_SESSION['refresh'] != "")
	{
		$auto_refresh = $_SESSION['refresh'];
	}
		
	
	header("refresh: $auto_refresh; url=controls.php");
	
	if ($_REQUEST['refresh'] == "Refresh")
	{
		header("location:controls.php");
	}
	
	//FusionPBX Integration
	require_once "fusionpbx/includes/header.php";

?>

<h3>Control Panel</h3>

<form method="" action="controls.php">
	<table width='100%' cellpadding='0' cellspacing='0' border='0'>
		<tr>
			<td width='50%'><b>Sangoma Media Gateway Status</b><br /></td>
			<td width='50%' align='right'>
	            <b>Auto Refresh</b>: <input type="text" name="auto_value" value="<?php echo $auto_refresh; ?>" style="width:30px" align="center" /> seconds<br />
                <input type='submit' name="refresh" value="Refresh" />
	   			<input type='submit' name="refresh_button" value="Update Interval"/>
	        </td>
		</tr>
	</table>
    <?php //<p><font color="red">NOTE: After starting the Sangoma Drivers and/or Sangoma Media Gateway, you must refresh the page or set the auto-refresh to shorter refresh intervals.</font></p> ?>
	<table border="4" width="300px">
		<th>Process</th>
	    <th>Status</th>
	    <tr>
			<td><b>Sangoma Media Gateway</b></td>
<?php
	
	exec("pidof sangoma-media-gateway",$output);
	if ($output[0] <= 0)
	{
		echo "<td align=\"center\" style=\"background-color:#FE0A10\"><font color=\"black\"><b>DOWN</b></td>";
		$free="down";
	}
	else
	{
		echo "<td align=\"center\" style=\"background-color:#00FF00\"><font color=\"black\"><b>UP</b></font></td>";
		$free="up";
	}

	unset($output);
?>
		</tr>
	    <tr>
	        <td><b>Sangoma TDM Driver</b></td>
<?php	
	exec ("wanrouter status | grep -c wanpipe", $output);
	if ($output[0] == 0)
	{
		echo "<td align=\"center\" style=\"background-color:#FE0A10\"><font color=\"black\"><b>DOWN</b></font></td>";
		$wan="down";
	}
	else
	{
		echo "<td align=\"center\" style=\"background-color:#00FF00\"><font color=\"black\"><b>UP</b></font></td>";
		$wan="up";
	}
	
	unset($output);

?>
		</tr>
	</table>
	<br />
	<hr />
	<h3>Controls</h3>

<?php
	if ($wan == "up")
	{
		
		echo "<h4>TDM Devices Available</h4>\n";
		exec ("grep \"WAN_DEVICES=\" /etc/wanpipe/wanrouter.rc", $output);
		
		echo "$output[0]<br /><br />\n";
		unset ($output);
		?><input type="submit" name="wan_stop" value="TDM Driver Stop" style="background-color: #CCC"/><?php
	}
	elseif($wan == "down")
	{
		?><input type="submit" name="wan_start" value="TDM Driver Start" style="background-color: #CCC"/><?php
	}
	if ($free == "down")
	{
    	?><input type="submit" name="free_start" value="SMG Start" style="background-color: #CCC"/><?php
	}
	elseif ($free == "up")
	{
    	?><input type="submit" name="free_stop" value="SMG Stop" style="background-color: #CCC"/><?php
	}
	if ($free == "up" && $wan == "up")
	{
    	?><input type="submit" name="wan_restart" value="SMG/TDM Driver Restart" style="background-color: #CCC"/><?php
	}
	if ($wan == "up")
	{
		?>
        <br /><br /><b>TDM Driver Selective Shutdown</b><br />
        Please enter wanpipe number in Textbox and click submit to stop that wanpipe device. For more than one wanpipe device, enter it as "<i>wanpipe1 wanpipe2 wanpipe4...</i>"<br />
        wanrouter stop <input type="text" name="wanpipe_stop_text" style="width: 100px" /><input type="submit" name="wanpipe_stop" value="submit" style="background-color: #CCC"/>
	    <?php
		if ($_REQUEST['wanpipe_stop_text'] == "" && $_REQUEST['wanpipe_stop'] == "submit")
		{
			echo "<font color=\"red\">* PLEASE ENTER A TDM DRIVER DEVICE</font>\n";
		}
		
	}
	if ($wan == "down" || $_SESSION['wan_complete'] == "NO")
	{
		?>
        <br /><br /><b>TDM Driver Selective Startup</b><br />
        Please enter wanpipe number in Textbox and click submit to start that wanpipe device. For more than one wanpipe device, enter it as "<i>wanpipe1 wanpipe2 wanpipe4...</i>"<br />
        wanrouter start <input type="text" name="wanpipe_start_text" style="width: 100px" /><input type="submit" name="wanpipe_start" value="submit" style="background-color: #CCC"/>
	    <?php
		if ($_REQUEST['wanpipe_start_text'] == "" && $_REQUEST['wanpipe_start'] == "submit")
		{
			echo "<font color=\"red\">* PLEASE ENTER A TDM DRIVER DEVICE</font>\n";
		}
	}
	
?>
	</form>
<br />
<hr />
	
<?php
	if ($_SESSION['wanrouter_error'] > 0)
	{
		//exec ("ln -s /var/log/messages messages");
		//exec ("ln -s /var/log/wanrouter wanrouter");
		//sleep(5);
		echo "<font color=\"red\"><b>ERROR</b></font><br />";
		echo "<font color=\"red\">THERE WAS AN ERROR STARTING THE SANGOMA TDM DRIVER. PLEASE CONSULT <a href=\"logs/messages\" target=\"_blank\">/VAR/LOG/MESSAGES</a> OR <a href=\"logs/wanrouter\" target=\"_blank\">/VAR/LOG/WANROUTER</a> FOR THE ERROR REASON OF THE ERROR</font><BR />";
		//exec ("rm -f messages");
		//exec ("rm -f wanrouter");
	}
	if ($wan == "up")
	{	
		echo "<b>TDM Driver Status</b><br />\n";
		exec ("cat /proc/net/wanrouter/status", $output);
		$counter = count($output);
		
		echo "<pre>\n";
		for ($a = 0; $a <= $counter; $a++)
		{
			echo "$output[$a]<br />";
		}
		echo "</pre>";
	}
	if ($_REQUEST['wanpipe_stop'] == "submit" && $_REQUEST['wanpipe_stop_text'] != "")
	{
		$cmd = "/usr/sbin/wanrouter stop " . $_REQUEST['wanpipe_stop_text'];
		exec ($cmd);
		$_SESSION['reload'] = "yes";
		header( 'Location:controls.php' ) ;
	}
	if ($_REQUEST['wanpipe_start'] == "submit" && $_REQUEST['wanpipe_start_text'] != "")
	{
		$cmd = "/usr/sbin/wanrouter start " . $_REQUEST['wanpipe_start_text'];
		exec ($cmd);	
		$_SESSION['reload'] = "yes";
		$_SESSION['wan_complete'] = "NO";
		header( 'Location:controls.php' ) ;
	}
	if ($_REQUEST['wan_stop'] == "TDM Driver Stop")
	{
		exec("/usr/sbin/wanrouter stop all &",$output);
		$_SESSION['reload'] = "yes";
		header( 'Location:controls.php' ) ;
	}
	if ($_REQUEST['wan_start'] == "TDM Driver Start")
	{
		exec("/usr/sbin/wanrouter start &> /usr/local/smg/nginx/html/php/temp", $output);
		exec ("grep -E 'ERROR|ioctl' -c temp", $output);
		exec ("rm -f temp");

		for ($a = 0; $a <= count($output); $a++)
		{
			echo "<pre>$output[$a]</pre>";
		}
		//exec("wanrouter start", $output);
		if ($output[0] > 0)
		{
			exec ("wanrouter stop all");
			$_SESSION['wanrouter_error'] = $output[0];
		}
		else
		{
			unset($_SESSION['wanrouter_error']);
		}
		$_SESSION['reload'] = "yes";	
		header( 'Location:controls.php' ) ;
	}
	if ($_REQUEST['free_start'] == "SMG Start")
	{
		//echo "starting\n";
		//shell_exec ("/etc/init.d/sangoma-media-gateway start &");
		system("/etc/init.d/sangoma-media-gateway start &> /dev/null");
		//echo "done starting\n";
		$_SESSION['reload'] = "yes";
		header( 'Location:controls.php' ) ;
	}
	if ($_REQUEST['free_stop'] == "SMG Stop")
	{
		system("/etc/init.d/sangoma-media-gateway stop &> /dev/null");
		$_SESSION['reload'] = "yes";
		header( 'Location:controls.php' ) ;
	}
	if ($_REQUEST['wan_restart'] == "SMG/TDM Driver Restart")
	{
		system ("/etc/init.d/sangoma-media-gateway stop &> /dev/null");

		exec("/usr/sbin/wanrouter stop all &",$output);
		exec("/usr/sbin/wanrouter start &> /usr/local/smg/nginx/html/php/temp", $output);
		exec ("grep -E 'ERROR|ioctl' -c temp", $output);
		exec ("rm -f temp");

		for ($a = 0; $a <= count($output); $a++)
		{
			echo "<pre>$output[$a]</pre>";
		}
		//exec("wanrouter start", $output);
		if ($output[0] > 0)
		{
			exec ("/usr/sbin/wanrouter stop all");
			$_SESSION['wanrouter_error'] = $output[0];
		}
		else
		{
			unset($_SESSION['wanrouter_error']);
		}
		system ("/etc/init.d/sangoma-media-gateway start &> /dev/null");
		$_SESSION['reload'] = "yes";
		header( 'Location:controls.php' ) ;
	}

	//FusionPBX Integration
	require_once "fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:index.php' ) ;
}
?>
