<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

	//Starts PHP Session
	session_start();
if ($_SESSION['username'] != "")
{	
	//PHP Includes
	include 'create_ss7_linkset_class.php';
	include '../database_classes.php';
	
	//PHP Class Constructor
	$data = new database_class;
	$ss7_linkset = new create_ss7_linkset_profile;
	
	$db_location = "sqlite:../sqlite/cardinfo.db";

	//If statement that controls the HTML Title & gets the information out of the database if you are performing editing.
	if ($_SESSION['id_num'] == "") 
	{ 
		$title = $_SESSION['line_type'] . " Profile Creation"; 
	} 
	else 
	{ 
		$title = "Edit Profile"; 
		//echo "id = " . $_SESSION['id_num'] . "<br />";
		$id = $_SESSION['id_num'];
		
		//Pull the information out of the database and save it in the class variable "edit"
		$ss7_linkset->edit = $data->select_statement($db_location, "ss7_linkset_profile", "*", "id = $id");
		$ss7_linkset->profile = $ss7_linkset->edit['profile_name'];
		$ss7_linkset->apc = $ss7_linkset->edit['apc'];
		$ss7_linkset->minactive = $ss7_linkset->edit['minactive'];
	}	

	
	if ($_REQUEST['create'] == "Create Profile" || $_REQUEST['create'] == "Save Profile")
	{
		//Runs the validation script
		$ss7_linkset->validation();
		
		//If there are no errors, place in the database
		if ($ss7_linkset->error_counter == 0)
		{
			$_SESSION['last_profile'] = $_REQUEST['profile_name'];
			
			//Check if it is a the profile is in the database
			if ($_SESSION['id_num'] != "")
			{
				$exist = $data->select_statement($db_location, "ss7_linkset_profile", "profile_name", "id = $id");
			}
			$id = $data->select_statement($db_location, "ss7_linkset_profile", "id", "");
			
			$id[0]++;
			
			if ($exist['profile_name'] == "")
			{
				//Line doesn't exist, insert it
				$insert_param = "id, profile_name, apc, minactive";
				$insert_values = "$id[0], \"" . $_REQUEST['profile_name'] . "\", \"" . $_REQUEST['apc'] . "\", \"" . $_REQUEST['minactive'] . "\"";
				
				$data->insert_statement($db_location, "ss7_linkset_profile", $insert_param, $insert_values);
			}
			elseif ($exist['profile_name'] != "")
			{
				//Line exists, update it
				$update_param = "profile_name = \"" . $_REQUEST['profile_name'] . "\", apc = \"" . $_REQUEST['apc'] . "\", minactive = \"" . $_REQUEST['minactive'] . "\"";

				$where_param = "id = " . $_SESSION['id_num'];
				
				$data->update_table($db_location, "ss7_linkset_profile", $update_param, $where_param);
			}
			
			if ($_SESSION['skip_all'] == "yes")
			{
				$_SESSION['profile_num_linkset']--;
				
				$port = $_SESSION['port_num_clicked'];
	
				$update_where = "port_id = $port";	
				$insert_param = "linkset";
				$update_param = "linkset = \"" . $_REQUEST['profile_name'] . "\"";
				$insert_values = "\"" . $_REQUEST['profile_name'] . "\"";													
			
				//Checks to see if the line exists
				$sig_param = "port_id = $port";
				
				$table_name =  $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_link";
				$param = "port_id";
	
				$sig_info = $data->select_statement ($db_location, $table_name, $param, $sig_param);						
				
				if ($sig_info['port_id'] != "")
				{
					//Port ID found, please update that port
					$data->update_table($db_location,$table_name, $update_param, $update_where);
				}
				if ($sig_info['port_id'] == "")
				{
					//echo "I am here <br />";
					//Insert the line
					$data->insert_statement($db_location, $table_name, $insert_param, $insert_values);
				}
								
				header( 'Location:create_ss7_route.php' ) ;
			}
			else
			{
				//Redirects to viewing all profiles page
				header( 'Location:view_ss7_linkset.php' ) ;			
			}			
		}
		else
		{
			$ss7_linkset->profile = $_REQUEST['profile_name'];
			$ss7_linkset->apc = $_REQUEST['apc'];
			$ss7_linkset->minactive = $_REQUEST['minactive'];			
		}
	}
	if ($_REQUEST['cancel'] == "Cancel Profile Creation" || $_REQUEST['cancel'] == "Cancel Profile Editing")
	{
		$_SESSION['id_num'] = "";
		
		$_SESSION['profile_num_linkset'] = $_SESSION['profile_num_linkset'] - 2;
		
		if ($_SESSION['skip_all'] == "yes")
		{
			unset($_SESSION['skip_all']);
			header( 'Location:../wanrouterhwprobe.php' );				

		}
		else
		{
			//Redirects to viewing all profiles page
			header( 'Location:view_ss7_linkset.php' ) ;			
		}
	}

	//FusionPBX Integration
	require_once "../fusionpbx/includes/header.php";

	//$display_common->html_title($title, "../../style.css" );	
	
	$ss7_linkset->display();	
	//$display_common->html_footer();

	//FusionPBX Integration
	require_once "../fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:../index.php' ) ;
}	
?>